//remove
ServerEvents.recipes(event => {
    event.remove({ id: 'draconicevolution:grinder' });
    event.remove({ id: 'draconicevolution:stabilized_spawner' });

    event.remove({ id: 'doom:chainsaw' });
    event.remove({ id: 'doom:chainsaw64' });
    event.remove({ id: 'doom:ballista' });
    event.remove({ id: 'doom:bfg9000' });
    event.remove({ id: 'doom:bfg_eternal' });
    event.remove({ id: 'doom:chaingun' });
    event.remove({ id: 'doom:chainsaweternal' });
    event.remove({ id: 'doom:doomed_gauss' });
    event.remove({ id: 'doom:doomed_plasma_rifle' });
    event.remove({ id: 'doom:doomed_shotgun' });
    event.remove({ id: 'doom:heavycannon' });
    event.remove({ id: 'doom:pistol' });
    event.remove({ id: 'doom:plasmagun' });
    event.remove({ id: 'doom:rocketlauncher' });
    event.remove({ id: 'doom:shotgun' });
    event.remove({ id: 'doom:supershotgun' });
    event.remove({ id: 'doom:unmaker' });
    event.remove({ id: 'doom:unmaykr' });
    event.remove({ id: 'doom:shotgun' });

    event.remove({ id: 'iceandfire:dragonforge_fire_core_disabled' });
    event.remove({ id: 'iceandfire:dragonforge_ice_core_disabled' });
    event.remove({ id: 'iceandfire:dragonforge_lightning_core_disabled' });
    event.remove({ id: 'iceandfire:dragonforge_fire_brick' });
    event.remove({ id: 'iceandfire:dragonforge_ice_brick' });
    event.remove({ id: 'iceandfire:dragonforge_lightning_brick' });
    event.remove({ id: 'iceandfire:dragonforge/dragonsteel_fire_ingot' });
    event.remove({id: "iceandfire:dragonforge/dragonsteel_ice_ingot"})
    event.remove({ id: 'iceandfire:dragonforge/dragonsteel_lightning_ingot' });


    event.remove({ id: 'powder_power:quadrilium_smithing_upgrade_template' });

    event.remove({ id: 'botania:spawner_mover' });

    event.remove({ id: 'witherstormmod:formidibomb' });

    event.remove({ id: 'powder_power:token_night_vision' });
    event.remove({ id: 'powder_power:token_speed' });
    event.remove({ id: 'powder_power:token_no_fall' });
    event.remove({ id: 'powder_power:token_healing' });
    event.remove({ id: 'powder_power:token_jump_boost' });
    event.remove({ id: 'powder_power:token_haste' });
    event.remove({ id: 'powder_power:token_breathing' });
    event.remove({ id: 'powder_power:token_good_omen' });
    event.remove({ id: 'powder_power:token_greater_healing' });
    event.remove({ id: 'powder_power:token_conduit_power' });
    event.remove({ id: 'powder_power:token_resistance' });
    event.remove({ id: 'powder_power:token_strength' });
    event.remove({ id: 'powder_power:token_absorption' });
    event.remove({ id: 'powder_power:token_greater_resistance' });
    event.remove({ id: 'powder_power:token_greater_strength' });
    event.remove({ id: 'powder_power:token_health' });
    event.remove({ id: 'powder_power:token_curing' });
    event.remove({ id: 'powder_power:token_greater_absorption' });
    event.remove({ id: 'powder_power:token_supreme_resistance' });
    event.remove({ id: 'powder_power:token_supreme_health' });
    event.remove({ id: 'powder_power:token_supreme_strength' });
    event.remove({ id: 'powder_power:token_supreme_exp' });
    event.remove({ id: 'powder_power:token_affliction' });

    event.remove({ id: 'celestisynth:solaris' });
    event.remove({ id: 'celestisynth:crescentia' });
    event.remove({ id: 'celestisynth:breezebreaker' });
    event.remove({ id: 'celestisynth:poltergeist' });
    event.remove({ id: 'celestisynth:aquaflora' });
    event.remove({ id: 'celestisynth:rainfall_serenity' });
    event.remove({ id: 'celestisynth:frostbound' });
    event.remove({ id: 'celestisynth:keres' });

    event.remove({ id: 'endrem:witch_eye' });
    event.remove({ id: 'endrem:undead_eye' });
    event.remove({ id: 'endrem:exotic_eye' });
    event.remove({ id: 'endrem:undead_eye' });

    event.remove({ id: 'spawnermod:spawner_key' });

     event.remove({output: 'armageddon_mod:withered_bone_effigy'})
    event.remove({output: 'armageddon_mod:anhk_aegis'})
    event.remove({output: 'armageddon_mod:thorned_requital'})
    event.remove({output: 'armageddon_mod:life_necklace'})
    event.remove({output: 'armageddon_mod:anathema_gauntlet'})
    event.remove({output: 'armageddon_mod:vagabonds_hood'})
    event.remove({output: 'armageddon_mod:ankh_tablet'})
});





// add
ServerEvents.recipes(event => {
    //Ice and fire
    event.shaped(
        Item.of('iceandfire:dragonforge_fire_core_disabled'),
        [
            'AAA',
            'ABA',
            'AAA'
        ],
        {
            A: 'iceandfire:dragonforge_fire_brick',
            B: '#kubejs:fire_dragon_egg'
        }
    );

    event.shaped(
        Item.of('iceandfire:dragonforge_ice_core_disabled'),
        [
            'AAA',
            'ABA',
            'AAA'
        ],
        {
            A: 'iceandfire:dragonforge_ice_brick',
            B: '#kubejs:ice_dragon_egg'
        }
    );

    event.shaped(
        Item.of('iceandfire:dragonforge_lightning_core_disabled'),
        [
            'AAA',
            'ABA',
            'AAA'
        ],
        {
            A: 'iceandfire:dragonforge_lightning_brick',
            B: '#kubejs:lightning_dragon_egg'
        }
    );

    event.shaped(
        Item.of('iceandfire:dragonforge_fire_brick', 4),
        [
            'ABA',
            'BCB',
            'ABA'
        ],
        {
            A: '#kubejs:dragonscale_fire_block',
            B: 'minecraft:stone_bricks',
            C: 'iceandfire:fire_dragon_heart'
        }
    );
    event.shaped(
        Item.of('iceandfire:dragonforge_ice_brick', 4),
        [
            'ABA',
            'BCB',
            'ABA'
        ],
        {
            A: '#kubejs:dragonscale_ice_block',
            B: 'minecraft:stone_bricks',
            C: 'iceandfire:ice_dragon_heart'
        }
    );
    event.shaped(
        Item.of('iceandfire:dragonforge_lightning_brick', 4),
        [
            'ABA',
            'BCB',
            'ABA'
        ],
        {
            A: '#kubejs:dragonscale_lightning_block',
            B: 'minecraft:stone_bricks',
            C: 'iceandfire:lightning_dragon_heart'
        }
    );

    // Dragon Forge

    event.custom({
        "type": "iceandfire:dragonforge",
        "dragon_type": "fire",
        "cook_time": 20,
        "input": {
            "item": "powder_power:ingot_quadrilium"
        },
        "blood": {
            "item": "iceandfire:fire_dragon_blood"
        },
        "result": {
            "item": "iceandfire:dragonsteel_fire_ingot"
        }
    })



    // Powder Power
    event.shaped(
        Item.of('powder_power:quadrilium_smithing_upgrade_template'),
        [
            'AAA',
            'ABA',
            'AAA'
        ],
        {
            A: 'powder_power:ingot_quadrilium',
            B: 'minecraft:netherite_upgrade_smithing_template'
        }
    );

    // Witherstorm 

    event.shaped(
        Item.of('witherstormmod:formidibomb'),
        [
            'ABA',
            'BCB',
            'ABA'
        ],
        {
            A: 'minecraft:gunpowder',
            B: 'draconicevolution:awakened_draconium_block',
            C: 'witherstormmod:super_tnt'
        }
    );

    // Poweder Power

    event.shaped(
        Item.of('powder_power:token_night_vision'),
        [
            ' A ',
            'ABA',
            ' A '
        ],
        {
            A: 'powder_power:blend_redium',
            B: 'forbidden_arcanus:edelwood_bat_bucket'
        }
    );

    event.shaped(
        Item.of('powder_power:token_speed'),
        [
            ' A ',
            'ABA',
            ' A '
        ],
        {
            A: 'powder_power:blend_redium',
            B: 'alexsmobs:roadrunner_boots'
        }
    );

    event.shaped(
        Item.of('powder_power:token_no_fall'),
        [
            'CAC',
            'ABA',
            'CAC'
        ],
        {
            A: 'powder_power:blend_redium',
            B: 'botania:fallen_kanade',
            C: 'minecraft:feather'
        }
    );

    event.shaped(
        Item.of('powder_power:token_healing'),
        [
            ' A ',
            'ABA',
            ' A '
        ],
        {
            A: 'powder_power:blend_redium',
            B: 'minecraft:enchanted_golden_apple'
        }
    );

    event.shaped(
        Item.of('powder_power:token_jump_boost'),
        [
            'BAB',
            'ABA',
            'BAB'
        ],
        {
            A: 'powder_power:blend_lapium',
            B: 'minecraft:rabbit_foot'
        }
    );

    event.shaped(
        Item.of('powder_power:token_haste'),
        [
            ' A ',
            'ABA',
            ' A '
        ],
        {
            A: 'powder_power:blend_lapium',
            B: 'minecraft:netherite_pickaxe'
        }
    );

    event.shaped(
        Item.of('powder_power:token_breathing'),
        [
            ' A ',
            'ABA',
            ' A '
        ],
        {
            A: 'powder_power:blend_lapium',
            B: 'alexsmobs:blobfish'
        }
    );

    event.shaped(
        Item.of('powder_power:token_good_omen'),
        [
            ' A ',
            'ABA',
            ' A '
        ],
        {
            A: 'powder_power:blend_gemium',
            B: 'betterarcheology:villager_fossil_head'
        }
    );

    event.shaped(
        Item.of('powder_power:token_greater_healing'),
        [
            ' A ',
            'ABA',
            ' A '
        ],
        {
            A: 'powder_power:block_trillium',
            B: 'powder_power:token_healing'
        }
    );

    event.shaped(
        Item.of('powder_power:token_conduit_power'),
        [
            'ACA',
            'ABA',
            'ADA '
        ],
        {
            A: 'powder_power:blend_trilium',
            B: 'minecraft:conduit',
            C: 'powder_power:token_breathing',
            D: 'powder_power:token_night_vision',
        }
    );

    event.shaped(
        Item.of('powder_power:token_resistance'),
        [
            ' A ',
            'ABA',
            ' A '
        ],
        {
            A: 'powder_power:blend_trilium',
            B: 'immersiveengineering:shield'
        }
    );

    event.shaped(
        Item.of('powder_power:token_strength'),
        [
            ' A ',
            'ABA',
            ' A '
        ],
        {
            A: 'powder_power:blend_trilium',
            B: 'minecraft:netherite_sword'
        }
    );

    event.shaped(
        Item.of('powder_power:token_absorption'),
        [
            'BAB',
            'ABA',
            'BAB'
        ],
        {
            A: 'powder_power:blend_trilium',
            B: 'minecraft:totem_of_undying'
        }
    );

    event.shaped(
        Item.of('powder_power:token_greater_resistance'),
        [
            'ABA',
            'BCB',
            'AAA'
        ],
        {
            A: 'powder_power:blend_quadrilium',
            B: 'powder_power:token_resistance',
            C: '#kubejs:dragonsteel_ingot'
        }
    );

    event.shaped(
        Item.of('powder_power:token_greater_strength'),
        [
            'ABA',
            'BCB',
            'AAA'
        ],
        {
            A: 'powder_power:blend_quadrilium',
            B: 'powder_power:token_strength',
            C: '#kubejs:dragonsteel_ingot'
        }
    );

    event.shaped(
        Item.of('powder_power:token_health'),
        [
            'ABA',
            'BCB',
            'AAA'
        ],
        {
            A: 'powder_power:blend_quadrilium',
            B: 'powder_power:token_absorption',
            C: '#kubejs:dragonsteel_ingot'
        }
    );

    event.shaped(
        Item.of('powder_power:token_curing'),
        [
            'ABA',
            'BCB',
            'AAA'
        ],
        {
            A: 'powder_power:blend_quadrilium',
            B: 'powder_power:token_health',
            C: '#kubejs:dragonsteel_ingot'
        }
    );

    event.shaped(
        Item.of('powder_power:token_greater_absorption'),
        [
            'ABA',
            'BCB',
            'AAA'
        ],
        {
            A: 'powder_power:ingot_quadrilium',
            B: 'powder_power:token_absorption',
            C: '#kubejs:dragonsteel_ingot'
        }
    );

    event.shaped(
        Item.of('powder_power:token_supreme_health'),
        [
            'ABA',
            'BCB',
            'AAA'
        ],
        {
            A: 'powder_power:block_quadrilium',
            B: 'powder_power:token_health',
            C: '#kubejs:dragonsteel_ingot'
        }
    );

    event.shaped(
        Item.of('powder_power:token_supreme_resistance'),
        [
            'ABA',
            'BCB',
            'AAA'
        ],
        {
            A: 'powder_power:block_quadrilium',
            B: 'powder_power:token_resistance',
            C: '#kubejs:dragonsteel_ingot'
        }
    );

    event.shaped(
        Item.of('powder_power:token_supreme_strength'),
        [
            'ABA',
            'BCB',
            'AAA'
        ],
        {
            A: 'powder_power:block_quadrilium',
            B: 'powder_power:token_greater_strength',
            C: '#kubejs:dragonsteel_ingot'
        }
    );

    event.shaped(
        Item.of('powder_power:token_exp'),
        [
            'ABA',
            'BCB',
            'ABA'
        ],
        {
            A: 'create:experience_block',
            B: 'powder_power:lapium_blend',
            C: 'artifacts:golden_hook'
        }
    );

    //celestisynth
    event.custom({
        "type": "celestisynth:starlit_factory",
        "forging_time": 1500,
        "result": "celestisynth:solaris",
        "core_material": {
            "item": "celestisynth:solar_crystal"
        },
        "extra_core_material": {
            "item": "celestisynth:supernal_netherite_ingot"
        },
        "supporting_core_material": {
            "item": "celestisynth:solar_crystal"
        },
        "supporting_material_bottom": {
            "item": "endrem:cryptic_eye"
        },
        "supporting_material_middle": {
            "item": "embers:wildfire_core"
        },
        "supporting_material_top": {
            "item": "iceandfire:dragonsteel_fire_sword"
        }
    })

    event.custom({
        "type": "celestisynth:starlit_factory",
        "forging_time": 1500,
        "result": "celestisynth:aquaflora",
        "core_material": {
            "item": "minecraft:heart_of_the_sea"
        },
        "extra_core_material": {
            "item": "celestisynth:supernal_netherite_ingot"
        },
        "supporting_core_material": {
            "item": "endrem:exotic_eye"
        },
        "supporting_material_bottom": {
            "item": "iceandfire:seaserpent_skull"
        },
        "supporting_material_middle": {
            "item": "forbidden_arcanus:sea_prism"
        },
        "supporting_material_top": {
            "item": "iceandfire:dragonsteel_ice_sword"
        }
    })

    event.custom({
        "type": "celestisynth:starlit_factory",
        "forging_time": 1500,
        "result": "celestisynth:rainfall_serenity",
        "core_material": {
            "item": "celestisynth:starstruck_scrap"
        },
        "extra_core_material": {
            "item": "celestisynth:supernal_netherite_ingot"
        },
        "supporting_core_material": {
            "item": "aquaculture:neptunium_bow"
        },
        "supporting_material_bottom": {
            "item": "endrem:rogue_eye"
        },
        "supporting_material_middle": {
            "item": "celestisynth:starstruck_feather"
        },
        "supporting_material_top": {
            "item": "iceandfire:dragonsteel_lightning_sword"
        }
    })

    event.custom({
        "type": "celestisynth:starlit_factory",
        "forging_time": 1500,
        "result": "celestisynth:keres",
        "core_material": {
            "item": "celestisynth:crimson_piece"
        },
        "extra_core_material": {
            "item": "celestisynth:supernal_netherite_ingot"
        },
        "supporting_core_material": {
            "item": "celestisynth:crimson_piece"
        },
        "supporting_material_bottom": {
            "item": "endrem:nether_eye"
        },
        "supporting_material_middle": {
            "item": "minecraft:netherite_ingot"
        },
        "supporting_material_top": {
            "item": "iceandfire:dragonsteel_fire_sword"
        }
    })

    event.custom({
        "type": "celestisynth:starlit_factory",
        "forging_time": 1500,
        "result": "celestisynth:frostbound",
        "core_material": {
            "item": "celestisynth:wintereis_shard"
        },
        "extra_core_material": {
            "item": "celestisynth:supernal_netherite_ingot"
        },
        "supporting_core_material": {
            "item": "mowziesmobs:ice_crystal"
        },
        "supporting_material_bottom": {
            "item": "endrem:black_eye"
        },
        "supporting_material_middle": {
            "item": "biomeswevegone:black_ice"
        },
        "supporting_material_top": {
            "item": "iceandfire:dragonsteel_ice_sword"
        }
    })

    event.custom({
        "type": "celestisynth:starlit_factory",
        "forging_time": 1500,
        "result": "celestisynth:poltergeist",
        "core_material": {
            "item": "celestisynth:eyebomination"
        },
        "extra_core_material": {
            "item": "celestisynth:supernal_netherite_ingot"
        },
        "supporting_core_material": {
            "item": "celestisynth:eyebomination"
        },
        "supporting_material_bottom": {
            "item": "endrem:undead_eye"
        },
        "supporting_material_middle": {
            "item": "embers:dawnstone_anvil"
        },
        "supporting_material_top": {
            "item": "iceandfire:dragonsteel_fire_axe"
        }
    })

    event.custom({
        "type": "celestisynth:starlit_factory",
        "forging_time": 1500,
        "result": "celestisynth:breezebreaker",
        "core_material": {
            "item": "forbidden_arcanus:whirlwind_prism"
        },
        "extra_core_material": {
            "item": "celestisynth:supernal_netherite_ingot"
        },
        "supporting_core_material": {
            "item": "forbidden_arcanus:whirlwind_prism"
        },
        "supporting_material_bottom": {
            "item": "endrem:cold_eye"
        },
        "supporting_material_middle": {
            "item": "embers:dawnstone_ingot"
        },
        "supporting_material_top": {
            "item": "iceandfire:dragonsteel_lightning_sword"
        }
    })

    event.custom({
        "type": "celestisynth:starlit_factory",
        "forging_time": 1500,
        "result": "celestisynth:crescentia",
        "core_material": {
            "item": "celestisynth:lunar_scrap"
        },
        "extra_core_material": {
            "item": "celestisynth:supernal_netherite_ingot"
        },
        "supporting_core_material": {
            "item": "celestisynth:lunar_scrap"
        },
        "supporting_material_bottom": {
            "item": "iceandfire:tide_trident"
        },
        "supporting_material_middle": {
            "item": "endrem:exotic_eye"
        },
        "supporting_material_top": {
            "item": "iceandfire:dragonsteel_ice_sword"
        }
    })

});


    



// hide
ServerEvents.tags("item", e => {
    let ae_hide = [
        "draconicevolution:grinder",
        "draconicevolution:stabilized_spawner",

        "doom:chainsaw",
        "doom:chainsaw64",
        "doom:ballista",
        "doom:bfg9000",
        "doom:bfg_eternal",
        "doom:chaingun",
        "doom:chainsaweternal",
        "doom:doomed_gauss",
        "doom:doomed_plasma_rifle",
        "doom:doomed_shotgun",
        "doom:heavycannon",
        "doom:pistol",
        "doom:plasmagun",
        "doom:rocketlauncher",
        "doom:shotgun",
        "doom:supershotgun",
        "doom:unmaker",
        "doom:unmaykr",
        "doom:shotgun"
    ];
    ae_hide.forEach(element => {
            e.add("c:hidden_from_recipe_viewers", element);
    });
})